Subject: Re: [net-next-2.6 PATCH v2 1/3] ethtool: Introduce n-tuple filter programming support

From: Jeff Garzik <[email-masked]>
Date: Thu, 04 Feb 2010 17:55:51 -0500

On 02/04/2010 05:52 PM, Peter P Waskiewicz Jr wrote:
> On Thu, 2010-02-04 at 14:34 -0800, Jeff Garzik wrote:
>> On 02/04/2010 04:26 PM, Waskiewicz Jr, Peter P wrote:
>>> On Thu, 4 Feb 2010, David Miller wrote:
>>>
>>>> From: Jeff Kirsher<[email-masked]>
>>>> Date: Wed, 03 Feb 2010 23:48:13 -0800
>>>>
>>>>> +#define ETHTOOL_RXNTUPLE_ACTION_DROP -1
>>>>> +	struct list_head list;
>>>>> +};
>>>>
>>>> You can't do this.
>>>>
>>>> You put the list_head here in the kernel header, which BTW can
>>>> be used by userspace too, and then you elide it in the
>>>> ethtool utility copy of the header.
>>>>
>>>> Use an encapsulator if you must inside of the kernel, but keep the
>>>> userspace visible data structure clean of RCU and list_head
>>>> kernel datastructures.
>>>
>>> Ok.  I'll respin this asap.  Thanks for the quick review Dave.
>>
>> Great.  I'll look for the updated userspace patch, too, and put it into
>> the ethtool-2.6.34 pile (ie. ethtool-net-next).
>>
>
> I didn't plan on respinning the userspace side.  I put a container
> wrapped around the flow_spec struct to do the list management in the
> kernel.  This shouldn't need a change to userspace.

Well, I figured there would be some trivial tweaks and patch offsets, 
because we want to keep the kernel ethtool.h and userspace 
ethtool-copy.h headers in sync.

Either way, no big deal.  I'll make sure net-next and ethtool match up, 
after your userspace patch is applied, one way or the other.

	Jeff